common: replace chattr with $CHATTR_PROG
[xfstests-dev.git] / tests / ext4 / 007
1 #! /bin/bash
2 # FS QA Test No. 007
3 #
4 # Create and populate an ext4 filesystem, corrupt the primary superblock, then
5 # see how the kernel and e2fsck deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44
45 # real QA test starts here
46 _supported_fs ext4
47 _supported_os Linux
48
49 _require_scratch
50 test -n "${FORCE_FUZZ}" || _require_scratch_ext4_crc
51 _require_attrs
52
53 rm -f $seqres.full
54 TESTDIR="${SCRATCH_MNT}/scratchdir"
55 TESTFILE="${TESTDIR}/testfile"
56
57 echo "+ create scratch fs"
58 _scratch_mkfs_ext4 > /dev/null 2>&1
59 dumpe2fs -g "${SCRATCH_DEV}" > /dev/null 2>&1 || _notrun "dumpe2fs -g not supported"
60
61 echo "+ mount fs image"
62 _scratch_mount
63 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
64 nr_groups="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | tail -n 1 | cut -d : -f 1)"
65 test "${nr_groups}" -gt 0 || _notrun "scratch device not big enough for backup superblocks"
66 backup_sb="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | awk -F ':' 'BEGIN {x = 0;} {if (x == 0 && int($3) > 1) {print $3; x++;}}')"
67
68 echo "+ make some files"
69 mkdir -p "${TESTDIR}"
70 for x in `seq 1 128`; do
71         touch "${SCRATCH_MNT}/junk.${x}"
72         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
73         if [ "$x" -gt 64 ] && [ "$((inode % 64))" -eq 0 ]; then
74                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
75                 break
76         fi
77 done
78 for x in `seq 2 64`; do
79         touch "${TESTFILE}.${x}"
80 done
81 umount "${SCRATCH_MNT}"
82
83 echo "+ check fs"
84 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
85
86 echo "+ corrupt image"
87 dumpe2fs -g "${SCRATCH_DEV}" 2>/dev/null | awk -F ':' '{if ($1 == 0) {print $3}}' | while read blk; do
88         debugfs -w -R "zap_block ${blk}" "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "primary sb fuzz failed"
89 done
90
91 echo "+ mount image"
92 _scratch_mount 2> /dev/null && _fail "mount should not succeed"
93
94 echo "+ repair fs"
95 # Have to specify backup sb and blocksize here so we don't pick up superblocks
96 # scattered elsewhere on the scratch device.
97 echo e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
98 e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
99
100 echo "+ mount image (2)"
101 _scratch_mount
102
103 echo "+ chattr -R -i"
104 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
105
106 echo "+ modify files (2)"
107 broken=0
108 for x in `seq 1 64`; do
109         test -e "${TESTFILE}.${x}" || continue
110         stat "${TESTFILE}.${x}" >> /dev/null 2>&1
111         test $? -ne 0 && broken=1
112         echo moo | dd oflag=append of="${TESTFILE}.${x}" 2>/dev/null
113         test $? -ne 0 && broken=1
114 done
115 echo "broken: ${broken}"
116 umount "${SCRATCH_MNT}"
117
118 echo "+ check fs (2)"
119 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
120
121 status=0
122 exit